/***********************************************************************\ 
*									* 
*   File: scorpion/src/idlview/xidlview/help.h 
*				 					* 
*   Copyright (C) 1991 Vijay Anand
*									* 
*   The Scorpion System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you 	* 
*   retain credits referencing the University of Arizona and that you	* 
*   identify any changes you make.					* 
*									* 
*   Report problems to scorpion-project@cs.arizona.edu			* 
*   Direct all inquiries to:	The Scorpion Project			* 
*				Department of Computer Science		* 
*				Gould-Simpson Building			* 
*				University of Arizona			* 
*				Tucson, AZ 85721			* 
*				U.S.A.					* 
*									* 
*   Revision Log:							* 
*	$Log:$ 
*									* 
*   Edit Log:								* 
*									* 
\***********************************************************************/ 

/* this module has all the help strings */

char *
xidlview_help = "idlview is a Graphical Data Display \n\
Server for the Interface Description Language. This \n\
window called the Main Window represents the server. \n\
This window has four sub-windows. \n\n\
The top one is the text sub-window where the \n\
text will be displayed. The second one contains \n\
frequently used commands such as pane movement buttons \n\
and the End Session button. The third sub-window is the \n\
command sub-window where the command buttons \n\
for performing actions are located. The bottom \n\
sub-window is the status sub-window where the \n\
status messages are displayed. A dbx process has \n\
to first connect with idlview before it can display \n\
text on the idlview window. Several operations \n\
such as expand, more detail, explain can be performed \n\
on the displayed nodes. Other operations such as \n\
reading in a new Candle file, detaching the idlview \n\
connection with dbx, selecting a port, and quitting \n\
can also be selected.";

char *
freq_command_help = "This window has the pane movement \n\
buttons and the End Session button";

char*
command_help = "This is the window for command buttons.";

char *
status_help = "This is the status window. This window \n\
displays the status message of the connection \n\
between the dbx process and the idlview process, the \n\
mode of display and the Main Window ID.";

char *
text_help = "This is the text window. The text information about \n\
nodes are displayed in this window.";

char *
endsess_help = "This is the endsess button. Pressing this button \n\
terminates the current idlview session. Nodes in a \n\
previous session cannot be selected for expand, more \n\
detail operations.";

char *
port_help = "This is the select port button. A Port can be selected \n\
from the pull-down menu of available ports.";

char *
help_help = "This is the help button. Pressing this would give you \n\
help on idlview in general. Specific help can be got \n\
by pressing the right-most mouse button on top of the \n\
window element you want more help on.";

char *
cdlfil_help = "This is the select candle file button. Pressing this \n\
button, pops up a window that requests a candle file \n\
name that is to be read. Further references to nodes \n\
and ports are with respect to this Candle file.";

char *
expand_help = "This is the expand button. Pressing this button \n\
expands the selected node. This can be invoked  \n\
only within a session.";

char *
mordtl_help = "This is the more detail button. Pressing this button \n\
generates the address information for the selected \n\
node. This can be invoked only within a session.";

char *
detach_help = "This is the detach button. Pressing this button \n\
detaches the communication link between dbx and \n\
idlview, and resets the idlview window.";

char *
explain_help = "This is the explain button. This displays the \n\
specification for the selected node in the idlbrowse window. \n\
It displays a popup for specifying the idlbrowse PID.";


char *
quit_help = "This is the quit button. It provides an interactive way \n\
to quit idlview.";

char *
freeze_help = "This is the freeze button. This creates a new window with \n\
all the nodes listed until now. It provides a copy of the status of nodes \n\
at this time. Multiple freeze windows can created and maintained to provide\n\
a history of changes to the nodes.";

char *
change_mode_help = "This is the change mode toggle button. This toggles \n\
the display mode between text and graphics. Instances displayed are \n\
converted from one form to another upon pressing this button.";

char *
identify_help = "This identifies instances of a particular node in the Main \n\
Window and the Frozen Windows. In the Main Window, a popup with all the \n\
locations of the instance is created. A particular instance can be selected \n\
in the popup and that instance will be highlighted. In the Frozen Window, \n\
the instances are highlighted.";

char *
print_help = "This button prints the text displayed in the text window onto \n\
the screen or the printer. Printers can also be specified.";

char *
goto_help = "Members of a sequence or a set that are present elsewhere in the \n\
graphics window are represented by a place holder at the current location in \n\
the set or sequence. The Goto button moves the screen to the actual location \n\
of the node. Another click on this button moves back to the original location.";

char *
change_display_help = "This button is a toggle that changes the display mode \n\
between Graphics and Text. The current mode is displayed in the Status sub \n\
window.";

char *
refresh_help = "This button refreshes the Graphics window.";

char *
global_layout_help = "This button performs layout computation on the whole \n\
graph and displays the whole graph. The user can scroll through the entire \n\
canvas to view the full graph.";

char *
version_help = "This button displays the current version of idlview.";



char *down_help = "This button displays the pane below the current pane.";

char *up_help = "This button displays the pane above the current pane.";

char *right_help = "This button displays the pane to the right of the \n\
current pane.";

char *left_help = "This button displays the pane to the left of the \n\
current pane.";
